(document:surround "/std/base")

(document:id lb
             (listbox rows '(("item1" . "theme:disk-fd")
                             "item2"
                             ("item3" . "theme:disk-cd")
                             "item4"
                             "item5")
                      current 2))
(hbox
 (document:id item-name (edit "other-item"))
 (button "Append item" (when clicked (lb append-row (item-name text)))))
(button "Clear list" (when clicked (lb rows-clear)))
(button "Reset list" (when clicked (lb rows '(("item1" . "theme:disk-fd")
                                              "item2"
                                              ("item3" . "theme:disk-cd")
                                              "item4" 
                                              "item5"))))
;;Sample range operations
(button "New Pixmaps to 2 and 4"
        (when clicked
          (for-each
           (lambda(num) (lb (row-item num (cons #f "theme:disk-hd"))))
           '(1 3))))
(button "New Pixmaps to 2 - 4"
        (when clicked
          (for-each
           (lambda(num) (lb (row-item num (cons #f "theme:disk-hd"))))
           (iota 3 1))))
(button "Remove 2 - 4"
        (when clicked
          (for-each
           (lambda(num) (lb remove num))
           (reverse (iota 3 1)))))


;;Sample edit
(button "Exchange texts"
        (when clicked
          (let ((txt1 (car (lb row-item 0)))
                (txt3 (car (lb  row-item 2))))
            (lb row-item 2 txt1)
            (lb row-item 0 txt3))))

(button "Exchange pixmaps"
        (when clicked
          (let ((txt1 (cdr (lb row-item 0)))
                (txt3 (cdr (lb row-item 2))))
            (lb row-item 2 (cons #f txt1))
            (lb row-item 0 (cons #f txt3)))))
(button "Quit" (when clicked (document:end)))
